/*
 * This file was generated automatically by ExtUtils::ParseXS version 2.2210 from the
 * contents of CairoSurface.xs. Do not edit this file, edit CairoSurface.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST! 
 *
 */

#line 1 "CairoSurface.xs"
/*
 * Copyright (c) 2004-2006 by the cairo perl team (see the file README)
 *
 * Licensed under the LGPL, see LICENSE file for more information.
 *
 * $Id$
 */

#include <cairo-perl.h>
#include <cairo-perl-private.h>

#define NEED_sv_2pv_flags
#include "ppport.h"

#if CAIRO_VERSION < CAIRO_VERSION_ENCODE(1, 2, 0)

static HV *pointer_to_package = NULL;

/* A hex character represents four bits in the address of a pointer, so we'll
 * need BITS_PER_LONG/4 characters.  That's sizeof (long) * 2.  Add 2 for the
 * "0x" part.  Add 1 for the trailing \0.  Reasoning courtesy of Robert Love.
 */
#define MAX_KEY_LENGTH ((sizeof(long) * 2) + 2 + 1)

/* This stuff is also used in CairoPattern.xs, hence no static on the
 * functions.
 */

void
cairo_perl_package_table_insert (void *pointer, const char *package)
{
	char key[MAX_KEY_LENGTH];

	if (!pointer_to_package) {
		pointer_to_package = newHV ();
	}

	sprintf (key, "%p", pointer);
	hv_store (pointer_to_package, key, strlen (key), newSVpv (package, PL_na), 0);
}

const char *
cairo_perl_package_table_lookup (void *pointer)
{
	char key[MAX_KEY_LENGTH];
	SV **sv;

	if (!pointer_to_package) {
		return NULL;
	}

	sprintf (key, "%p", pointer);
	sv = hv_fetch (pointer_to_package, key, strlen (key), 0);
	if (sv && SvOK (*sv)) {
		return SvPV_nolen (*sv);
	}

	return NULL;
}

#endif /* !1.2.0 */

static const char *
get_package (cairo_surface_t *surface)
{
#if CAIRO_VERSION >= CAIRO_VERSION_ENCODE(1, 2, 0)
	cairo_surface_type_t type;
	const char *package;

	type = cairo_surface_get_type (surface);
	switch (type) {
	    case CAIRO_SURFACE_TYPE_IMAGE:
		package = "Cairo::ImageSurface";
		break;

	    case CAIRO_SURFACE_TYPE_PDF:
		package = "Cairo::PdfSurface";
		break;

	    case CAIRO_SURFACE_TYPE_PS:
		package = "Cairo::PsSurface";
		break;

	    case CAIRO_SURFACE_TYPE_SVG:
		package = "Cairo::SvgSurface";
		break;

#if CAIRO_VERSION >= CAIRO_VERSION_ENCODE(1, 10, 0)
	    case CAIRO_SURFACE_TYPE_RECORDING:
		package = "Cairo::RecordingSurface";
		break;
#endif

	    case CAIRO_SURFACE_TYPE_XLIB:
	    case CAIRO_SURFACE_TYPE_XCB:
	    case CAIRO_SURFACE_TYPE_GLITZ:
	    case CAIRO_SURFACE_TYPE_QUARTZ:
	    case CAIRO_SURFACE_TYPE_WIN32:
	    case CAIRO_SURFACE_TYPE_BEOS:
	    case CAIRO_SURFACE_TYPE_DIRECTFB:
	    case CAIRO_SURFACE_TYPE_OS2:
	    case CAIRO_SURFACE_TYPE_WIN32_PRINTING:
	    case CAIRO_SURFACE_TYPE_QUARTZ_IMAGE:
#if CAIRO_VERSION >= CAIRO_VERSION_ENCODE(1, 10, 0)
	    case CAIRO_SURFACE_TYPE_SCRIPT:
	    case CAIRO_SURFACE_TYPE_QT:
	    case CAIRO_SURFACE_TYPE_VG:
	    case CAIRO_SURFACE_TYPE_GL:
	    case CAIRO_SURFACE_TYPE_DRM:
	    case CAIRO_SURFACE_TYPE_TEE:
	    case CAIRO_SURFACE_TYPE_XML:
	    case CAIRO_SURFACE_TYPE_SKIA:
	    case CAIRO_SURFACE_TYPE_SUBSURFACE:
#endif
		package = "Cairo::Surface";
		break;

	    default:
		warn ("unknown surface type %d encountered", type);
		package = "Cairo::Surface";
		break;
	}

	return package;
#else
	const char *package = cairo_perl_package_table_lookup (surface);
	return package ? package : "Cairo::Surface";
#endif
}

SV *
cairo_surface_to_sv (cairo_surface_t *surface)
{
	SV *sv = newSV (0);
	sv_setref_pv(sv, get_package (surface), surface);
	return sv;
}

/* -------------------------------------------------------------------------- */

typedef struct {
	SV *func;
	SV *data;
	void *context;
} CairoPerlCallback;

#ifdef PERL_IMPLICIT_CONTEXT
# define dCAIRO_PERL_CALLBACK_MARSHAL_SP		\
	SV ** sp;
# define CAIRO_PERL_CALLBACK_MARSHAL_INIT(callback)	\
	PERL_SET_CONTEXT (callback->context);		\
	SPAGAIN;
#else
# define dCAIRO_PERL_CALLBACK_MARSHAL_SP		\
	dSP;
# define CAIRO_PERL_CALLBACK_MARSHAL_INIT(callback)	\
	/* nothing to do */
#endif

static CairoPerlCallback *
cairo_perl_callback_new (SV *func, SV *data)
{
	CairoPerlCallback *callback;

	Newz (0, callback, 1, CairoPerlCallback);

	callback->func = newSVsv (func);
	if (data)
		callback->data = newSVsv (data);

#ifdef PERL_IMPLICIT_CONTEXT
	callback->context = aTHX;
#endif

	return callback;
}

static void
cairo_perl_callback_free (CairoPerlCallback *callback)
{
	SvREFCNT_dec (callback->func);
	if (callback->data)
		SvREFCNT_dec (callback->data);
	Safefree (callback);
}

/* -------------------------------------------------------------------------- */

/* Caller owns returned SV */
static SV *
strip_off_location (SV *error)
{
	SV *saved_defsv, *result;
	saved_defsv = newSVsv (DEFSV);
	ENTER;
	SAVETMPS;
	sv_setsv (DEFSV, error);
	eval_pv ("s/^([-_\\w]+) .+$/$1/s", FALSE);
	result = newSVsv (DEFSV);
	FREETMPS;
	LEAVE;
	sv_setsv (DEFSV, saved_defsv);
	SvREFCNT_dec (saved_defsv);
	return result;
}

static cairo_status_t
write_func_marshaller (void *closure,
                       const unsigned char *data,
                       unsigned int length)
{
	CairoPerlCallback *callback;
	cairo_status_t status = CAIRO_STATUS_SUCCESS;
	dCAIRO_PERL_CALLBACK_MARSHAL_SP;

	callback = (CairoPerlCallback *) closure;

	CAIRO_PERL_CALLBACK_MARSHAL_INIT (callback);

	ENTER;
	SAVETMPS;
	PUSHMARK (SP);

	EXTEND (SP, 2);
	PUSHs (callback->data ? callback->data : &PL_sv_undef);
	PUSHs (sv_2mortal (newSVpv ((const char *) data, length)));

	PUTBACK;
	call_sv (callback->func, G_DISCARD | G_EVAL);
	SPAGAIN;

	if (SvTRUE (ERRSV)) {
		SV *sv = strip_off_location (ERRSV);
		status = SvCairoStatus (sv);
		SvREFCNT_dec (sv);
	}

	PUTBACK;
	FREETMPS;
	LEAVE;

	return status;
}

/* -------------------------------------------------------------------------- */

static cairo_status_t
read_func_marshaller (void *closure,
                      unsigned char *data,
                      unsigned int length)
{
	CairoPerlCallback *callback;
	cairo_status_t status = CAIRO_STATUS_SUCCESS;
	dCAIRO_PERL_CALLBACK_MARSHAL_SP;

	callback = (CairoPerlCallback *) closure;

	CAIRO_PERL_CALLBACK_MARSHAL_INIT (callback);

	ENTER;
	SAVETMPS;
	PUSHMARK (SP);

	EXTEND (SP, 2);
	PUSHs (callback->data ? callback->data : &PL_sv_undef);
	PUSHs (sv_2mortal (newSVuv (length)));

	PUTBACK;
	call_sv (callback->func, G_SCALAR | G_EVAL);
	SPAGAIN;

	if (SvTRUE (ERRSV)) {
		SV *sv = strip_off_location (ERRSV);
		status = SvCairoStatus (sv);
		SvREFCNT_dec (sv);
	} else {
		SV *retval = POPs;
		memcpy (data, SvPV_nolen (retval), sv_len (retval));
	}

	PUTBACK;
	FREETMPS;
	LEAVE;

	return status;
}

/* -------------------------------------------------------------------------- */

#line 300 "CairoSurface.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
            Perl_croak(aTHX_ "Usage: %s::%s(%s)", hvname, gvname, params);
        else
            Perl_croak(aTHX_ "Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
        Perl_croak(aTHX_ "Usage: CODE(0x%"UVxf")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#ifdef PERL_IMPLICIT_CONTEXT
#define croak_xs_usage(a,b)	S_croak_xs_usage(aTHX_ a,b)
#else
#define croak_xs_usage		S_croak_xs_usage
#endif

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#line 352 "CairoSurface.c"

XS(XS_Cairo__Surface_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_Cairo__Surface_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "surface");
    {
	cairo_surface_t *	surface = SvCairoSurface (ST(0));
#line 294 "CairoSurface.xs"
	cairo_surface_destroy (surface);
#line 368 "CairoSurface.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Cairo__Surface_create_similar); /* prototype to pass -Wmissing-prototypes */
XS(XS_Cairo__Surface_create_similar)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 299 "CairoSurface.xs"
	int offset = 0;
	cairo_surface_t * other = NULL;
	cairo_content_t content = 0;
	int width = 0;
	int height = 0;
#line 390 "CairoSurface.c"
	cairo_surface_t_noinc *	RETVAL;
#line 305 "CairoSurface.xs"
	if (items == 4) {
		offset = 0;
	} else if (items == 5) {
		offset = 1;
	} else {
		croak ("Usage: Cairo::Surface->create_similar ($other, $content, $width, $height)\n"
		       " -or-: $other->create_similar ($content, $width, $height)");
	}
	other = SvCairoSurface (ST (0 + offset));
	content = SvCairoContent (ST (1 + offset));
	width = SvIV (ST (2 + offset));
	height = SvIV (ST (3 + offset));
	RETVAL = cairo_surface_create_similar (other, content, width, height);
#if CAIRO_VERSION < CAIRO_VERSION_ENCODE(1, 2, 0)
	{
	const char *package = cairo_perl_package_table_lookup (other);
	cairo_perl_package_table_insert (RETVAL, package ? package : "Cairo::Surface");
	}
#endif
#line 412 "CairoSurface.c"
	ST(0) = newSVCairoSurface_noinc (RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Cairo__Surface_finish); /* prototype to pass -Wmissing-prototypes */
XS(XS_Cairo__Surface_finish)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "surface");
    {
	cairo_surface_t *	surface = SvCairoSurface (ST(0));

	cairo_surface_finish(surface);
    }
    XSRETURN_EMPTY;
}


XS(XS_Cairo__Surface_status); /* prototype to pass -Wmissing-prototypes */
XS(XS_Cairo__Surface_status)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "surface");
    {
	cairo_status_t	RETVAL;
	cairo_surface_t *	surface = SvCairoSurface (ST(0));

	RETVAL = cairo_surface_status(surface);
	ST(0) = newSVCairoStatus (RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Cairo__Surface_set_device_offset); /* prototype to pass -Wmissing-prototypes */
XS(XS_Cairo__Surface_set_device_offset)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       croak_xs_usage(cv,  "surface, x_offset, y_offset");
    {
	cairo_surface_t *	surface = SvCairoSurface (ST(0));
	double	x_offset = (double)SvNV(ST(1));
	double	y_offset = (double)SvNV(ST(2));

	cairo_surface_set_device_offset(surface, x_offset, y_offset);
    }
    XSRETURN_EMPTY;
}

#if CAIRO_VERSION >= CAIRO_VERSION_ENCODE(1, 2, 0)
#define XSubPPtmpAAAA 1


XS(XS_Cairo__Surface_get_device_offset); /* prototype to pass -Wmissing-prototypes */
XS(XS_Cairo__Surface_get_device_offset)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "surface");
    {
	cairo_surface_t *	surface = SvCairoSurface (ST(0));
	double	x_offset;
	double	y_offset;

	cairo_surface_get_device_offset(surface, &x_offset, &y_offset);
	XSprePUSH;	EXTEND(SP,2);
	PUSHs(sv_newmortal());
	sv_setnv(ST(0), (double)x_offset);
	PUSHs(sv_newmortal());
	sv_setnv(ST(1), (double)y_offset);
    }
    XSRETURN(2);
}


XS(XS_Cairo__Surface_set_fallback_resolution); /* prototype to pass -Wmissing-prototypes */
XS(XS_Cairo__Surface_set_fallback_resolution)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       croak_xs_usage(cv,  "surface, x_pixels_per_inch, y_pixels_per_inch");
    {
	cairo_surface_t *	surface = SvCairoSurface (ST(0));
	double	x_pixels_per_inch = (double)SvNV(ST(1));
	double	y_pixels_per_inch = (double)SvNV(ST(2));

	cairo_surface_set_fallback_resolution(surface, x_pixels_per_inch, y_pixels_per_inch);
    }
    XSRETURN_EMPTY;
}

#endif
#if CAIRO_VERSION >= CAIRO_VERSION_ENCODE(1, 8, 0)
#define XSubPPtmpAAAB 1


XS(XS_Cairo__Surface_get_fallback_resolution); /* prototype to pass -Wmissing-prototypes */
XS(XS_Cairo__Surface_get_fallback_resolution)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "surface");
    {
	cairo_surface_t *	surface = SvCairoSurface (ST(0));
	double	x_pixels_per_inch;
	double	y_pixels_per_inch;

	cairo_surface_get_fallback_resolution(surface, &x_pixels_per_inch, &y_pixels_per_inch);
	XSprePUSH;	EXTEND(SP,2);
	PUSHs(sv_newmortal());
	sv_setnv(ST(0), (double)x_pixels_per_inch);
	PUSHs(sv_newmortal());
	sv_setnv(ST(1), (double)y_pixels_per_inch);
    }
    XSRETURN(2);
}

#endif

XS(XS_Cairo__Surface_get_font_options); /* prototype to pass -Wmissing-prototypes */
XS(XS_Cairo__Surface_get_font_options)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "surface");
    {
	cairo_font_options_t *	RETVAL;
	cairo_surface_t *	surface = SvCairoSurface (ST(0));
#line 350 "CairoSurface.xs"
	RETVAL = cairo_font_options_create ();
	cairo_surface_get_font_options (surface, RETVAL);
#line 579 "CairoSurface.c"
	ST(0) = newSVCairoFontOptions (RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Cairo__Surface_flush); /* prototype to pass -Wmissing-prototypes */
XS(XS_Cairo__Surface_flush)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "surface");
    {
	cairo_surface_t *	surface = SvCairoSurface (ST(0));

	cairo_surface_flush(surface);
    }
    XSRETURN_EMPTY;
}


XS(XS_Cairo__Surface_mark_dirty); /* prototype to pass -Wmissing-prototypes */
XS(XS_Cairo__Surface_mark_dirty)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "surface");
    {
	cairo_surface_t *	surface = SvCairoSurface (ST(0));

	cairo_surface_mark_dirty(surface);
    }
    XSRETURN_EMPTY;
}


XS(XS_Cairo__Surface_mark_dirty_rectangle); /* prototype to pass -Wmissing-prototypes */
XS(XS_Cairo__Surface_mark_dirty_rectangle)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 5)
       croak_xs_usage(cv,  "surface, x, y, width, height");
    {
	cairo_surface_t *	surface = SvCairoSurface (ST(0));
	int	x = (int)SvIV(ST(1));
	int	y = (int)SvIV(ST(2));
	int	width = (int)SvIV(ST(3));
	int	height = (int)SvIV(ST(4));

	cairo_surface_mark_dirty_rectangle(surface, x, y, width, height);
    }
    XSRETURN_EMPTY;
}

#if CAIRO_VERSION >= CAIRO_VERSION_ENCODE(1, 2, 0)
#define XSubPPtmpAAAC 1


XS(XS_Cairo__Surface_get_type); /* prototype to pass -Wmissing-prototypes */
XS(XS_Cairo__Surface_get_type)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "surface");
    {
	cairo_surface_type_t	RETVAL;
	cairo_surface_t *	surface = SvCairoSurface (ST(0));

	RETVAL = cairo_surface_get_type(surface);
	ST(0) = newSVCairoSurfaceType (RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Cairo__Surface_get_content); /* prototype to pass -Wmissing-prototypes */
XS(XS_Cairo__Surface_get_content)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "surface");
    {
	cairo_content_t	RETVAL;
	cairo_surface_t *	surface = SvCairoSurface (ST(0));

	RETVAL = cairo_surface_get_content(surface);
	ST(0) = newSVCairoContent (RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}

#endif
#ifdef CAIRO_HAS_PNG_FUNCTIONS
#define XSubPPtmpAAAD 1


XS(XS_Cairo__Surface_write_to_png); /* prototype to pass -Wmissing-prototypes */
XS(XS_Cairo__Surface_write_to_png)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "surface, filename");
    {
	cairo_status_t	RETVAL;
	cairo_surface_t *	surface = SvCairoSurface (ST(0));
	const char *	filename = (const char *)SvPV_nolen(ST(1));

	RETVAL = cairo_surface_write_to_png(surface, filename);
	ST(0) = newSVCairoStatus (RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Cairo__Surface_write_to_png_stream); /* prototype to pass -Wmissing-prototypes */
XS(XS_Cairo__Surface_write_to_png_stream)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "surface, func, data=NULL");
    {
#line 377 "CairoSurface.xs"
	CairoPerlCallback *callback;
#line 735 "CairoSurface.c"
	cairo_status_t	RETVAL;
	cairo_surface_t *	surface = SvCairoSurface (ST(0));
	SV *	func = ST(1);
	SV *	data;

	if (items < 3)
	    data = NULL;
	else {
	    data = ST(2);
	}
#line 379 "CairoSurface.xs"
	callback = cairo_perl_callback_new (func, data);
	RETVAL = cairo_surface_write_to_png_stream (surface,
	                                            write_func_marshaller,
	                                            callback);
	cairo_perl_callback_free (callback);
#line 752 "CairoSurface.c"
	ST(0) = newSVCairoStatus (RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}

#endif
#if CAIRO_VERSION >= CAIRO_VERSION_ENCODE (1, 6, 0)
#define XSubPPtmpAAAE 1


XS(XS_Cairo__Surface_copy_page); /* prototype to pass -Wmissing-prototypes */
XS(XS_Cairo__Surface_copy_page)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "surface");
    {
	cairo_surface_t *	surface = SvCairoSurface (ST(0));

	cairo_surface_copy_page(surface);
    }
    XSRETURN_EMPTY;
}


XS(XS_Cairo__Surface_show_page); /* prototype to pass -Wmissing-prototypes */
XS(XS_Cairo__Surface_show_page)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "surface");
    {
	cairo_surface_t *	surface = SvCairoSurface (ST(0));

	cairo_surface_show_page(surface);
    }
    XSRETURN_EMPTY;
}

#endif
#if CAIRO_VERSION >= CAIRO_VERSION_ENCODE (1, 8, 0)
#define XSubPPtmpAAAF 1


XS(XS_Cairo__Surface_has_show_text_glyphs); /* prototype to pass -Wmissing-prototypes */
XS(XS_Cairo__Surface_has_show_text_glyphs)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "surface");
    {
	cairo_bool_t	RETVAL;
	dXSTARG;
	cairo_surface_t *	surface = SvCairoSurface (ST(0));

	RETVAL = cairo_surface_has_show_text_glyphs(surface);
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}

#endif
#if CAIRO_VERSION >= CAIRO_VERSION_ENCODE (1, 10, 0)
#define XSubPPtmpAAAG 1


XS(XS_Cairo__Surface_create_for_rectangle); /* prototype to pass -Wmissing-prototypes */
XS(XS_Cairo__Surface_create_for_rectangle)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 6)
       croak_xs_usage(cv,  "class, target, x, y, width, height");
    {
	cairo_surface_t_noinc *	RETVAL;
	cairo_surface_t *	target = SvCairoSurface (ST(1));
	double	x = (double)SvNV(ST(2));
	double	y = (double)SvNV(ST(3));
	double	width = (double)SvNV(ST(4));
	double	height = (double)SvNV(ST(5));

	RETVAL = cairo_surface_create_for_rectangle(target, x, y, width, height);
	ST(0) = newSVCairoSurface_noinc (RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}

#endif

XS(XS_Cairo__ImageSurface_create); /* prototype to pass -Wmissing-prototypes */
XS(XS_Cairo__ImageSurface_create)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 4)
       croak_xs_usage(cv,  "class, format, width, height");
    {
	cairo_surface_t_noinc *	RETVAL;
	cairo_format_t	format = SvCairoFormat (ST(1));
	int	width = (int)SvIV(ST(2));
	int	height = (int)SvIV(ST(3));

	RETVAL = cairo_image_surface_create(format, width, height);
#line 425 "CairoSurface.xs"
#if CAIRO_VERSION < CAIRO_VERSION_ENCODE(1, 2, 0)
	cairo_perl_package_table_insert (RETVAL, "Cairo::ImageSurface");
#endif
#line 880 "CairoSurface.c"
	ST(0) = newSVCairoSurface_noinc (RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Cairo__ImageSurface_create_for_data); /* prototype to pass -Wmissing-prototypes */
XS(XS_Cairo__ImageSurface_create_for_data)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 6)
       croak_xs_usage(cv,  "class, data, format, width, height, stride");
    {
	cairo_surface_t_noinc *	RETVAL;
	unsigned char *	data = (unsigned char *)SvPV_nolen(ST(1));
	cairo_format_t	format = SvCairoFormat (ST(2));
	int	width = (int)SvIV(ST(3));
	int	height = (int)SvIV(ST(4));
	int	stride = (int)SvIV(ST(5));

	RETVAL = cairo_image_surface_create_for_data(data, format, width, height, stride);
#line 434 "CairoSurface.xs"
#if CAIRO_VERSION < CAIRO_VERSION_ENCODE(1, 2, 0)
	cairo_perl_package_table_insert (RETVAL, "Cairo::ImageSurface");
#endif
#line 911 "CairoSurface.c"
	ST(0) = newSVCairoSurface_noinc (RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}

#if CAIRO_VERSION >= CAIRO_VERSION_ENCODE(1, 2, 0)
#define XSubPPtmpAAAH 1


XS(XS_Cairo__ImageSurface_get_data); /* prototype to pass -Wmissing-prototypes */
XS(XS_Cairo__ImageSurface_get_data)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "surface");
    {
#line 444 "CairoSurface.xs"
	unsigned char *data;
	int height, stride;
#line 936 "CairoSurface.c"
	SV *	RETVAL;
	cairo_surface_t *	surface = SvCairoSurface (ST(0));
#line 447 "CairoSurface.xs"
	data = cairo_image_surface_get_data (surface);
	height = cairo_image_surface_get_height (surface);
	stride = cairo_image_surface_get_stride (surface);
	RETVAL = data ? newSVpv ((char *) data, height * stride) : &PL_sv_undef;
#line 944 "CairoSurface.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Cairo__ImageSurface_get_format); /* prototype to pass -Wmissing-prototypes */
XS(XS_Cairo__ImageSurface_get_format)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "surface");
    {
	cairo_format_t	RETVAL;
	cairo_surface_t *	surface = SvCairoSurface (ST(0));

	RETVAL = cairo_image_surface_get_format(surface);
	ST(0) = newSVCairoFormat (RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}

#endif

XS(XS_Cairo__ImageSurface_get_width); /* prototype to pass -Wmissing-prototypes */
XS(XS_Cairo__ImageSurface_get_width)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "surface");
    {
	int	RETVAL;
	dXSTARG;
	cairo_surface_t *	surface = SvCairoSurface (ST(0));

	RETVAL = cairo_image_surface_get_width(surface);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Cairo__ImageSurface_get_height); /* prototype to pass -Wmissing-prototypes */
XS(XS_Cairo__ImageSurface_get_height)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "surface");
    {
	int	RETVAL;
	dXSTARG;
	cairo_surface_t *	surface = SvCairoSurface (ST(0));

	RETVAL = cairo_image_surface_get_height(surface);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#if CAIRO_VERSION >= CAIRO_VERSION_ENCODE(1, 2, 0)
#define XSubPPtmpAAAI 1


XS(XS_Cairo__ImageSurface_get_stride); /* prototype to pass -Wmissing-prototypes */
XS(XS_Cairo__ImageSurface_get_stride)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "surface");
    {
	int	RETVAL;
	dXSTARG;
	cairo_surface_t *	surface = SvCairoSurface (ST(0));

	RETVAL = cairo_image_surface_get_stride(surface);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#endif
#ifdef CAIRO_HAS_PNG_FUNCTIONS
#define XSubPPtmpAAAJ 1


XS(XS_Cairo__ImageSurface_create_from_png); /* prototype to pass -Wmissing-prototypes */
XS(XS_Cairo__ImageSurface_create_from_png)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "class, filename");
    {
	cairo_surface_t_noinc *	RETVAL;
	const char *	filename = (const char *)SvPV_nolen(ST(1));

	RETVAL = cairo_image_surface_create_from_png(filename);
#line 475 "CairoSurface.xs"
#if CAIRO_VERSION < CAIRO_VERSION_ENCODE(1, 2, 0)
	cairo_perl_package_table_insert (RETVAL, "Cairo::ImageSurface");
#endif
#line 1067 "CairoSurface.c"
	ST(0) = newSVCairoSurface_noinc (RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Cairo__ImageSurface_create_from_png_stream); /* prototype to pass -Wmissing-prototypes */
XS(XS_Cairo__ImageSurface_create_from_png_stream)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "class, func, data=NULL");
    {
#line 483 "CairoSurface.xs"
	CairoPerlCallback *callback;
#line 1088 "CairoSurface.c"
	cairo_surface_t_noinc *	RETVAL;
	SV *	func = ST(1);
	SV *	data;

	if (items < 3)
	    data = NULL;
	else {
	    data = ST(2);
	}
#line 485 "CairoSurface.xs"
	callback = cairo_perl_callback_new (func, data);
	RETVAL = cairo_image_surface_create_from_png_stream (
			read_func_marshaller, callback);
	cairo_perl_callback_free (callback);
#if CAIRO_VERSION < CAIRO_VERSION_ENCODE(1, 2, 0)
	cairo_perl_package_table_insert (RETVAL, "Cairo::ImageSurface");
#endif
#line 1106 "CairoSurface.c"
	ST(0) = newSVCairoSurface_noinc (RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}

#endif
#ifdef CAIRO_HAS_PDF_SURFACE
#define XSubPPtmpAAAK 1


XS(XS_Cairo__PdfSurface_create); /* prototype to pass -Wmissing-prototypes */
XS(XS_Cairo__PdfSurface_create)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 4)
       croak_xs_usage(cv,  "class, filename, width_in_points, height_in_points");
    {
	cairo_surface_t_noinc *	RETVAL;
	const char *	filename = (const char *)SvPV_nolen(ST(1));
	double	width_in_points = (double)SvNV(ST(2));
	double	height_in_points = (double)SvNV(ST(3));

	RETVAL = cairo_pdf_surface_create(filename, width_in_points, height_in_points);
#line 511 "CairoSurface.xs"
#if CAIRO_VERSION < CAIRO_VERSION_ENCODE(1, 2, 0)
	cairo_perl_package_table_insert (RETVAL, "Cairo::PdfSurface");
#endif
#line 1139 "CairoSurface.c"
	ST(0) = newSVCairoSurface_noinc (RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Cairo__PdfSurface_create_for_stream); /* prototype to pass -Wmissing-prototypes */
XS(XS_Cairo__PdfSurface_create_for_stream)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 5)
       croak_xs_usage(cv,  "class, func, data, width_in_points, height_in_points");
    {
#line 519 "CairoSurface.xs"
	CairoPerlCallback *callback;
#line 1160 "CairoSurface.c"
	cairo_surface_t_noinc *	RETVAL;
	SV *	func = ST(1);
	SV *	data = ST(2);
	double	width_in_points = (double)SvNV(ST(3));
	double	height_in_points = (double)SvNV(ST(4));
#line 521 "CairoSurface.xs"
	callback = cairo_perl_callback_new (func, data);
	RETVAL = cairo_pdf_surface_create_for_stream (write_func_marshaller,
	                                              callback,
	                                              width_in_points,
	                                              height_in_points);
	cairo_surface_set_user_data (
		RETVAL, (const cairo_user_data_key_t *) &callback, callback,
		(cairo_destroy_func_t) cairo_perl_callback_free);
#if CAIRO_VERSION < CAIRO_VERSION_ENCODE(1, 2, 0)
	cairo_perl_package_table_insert (RETVAL, "Cairo::PdfSurface");
#endif
#line 1178 "CairoSurface.c"
	ST(0) = newSVCairoSurface_noinc (RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}

#if CAIRO_VERSION >= CAIRO_VERSION_ENCODE(1, 2, 0)
#define XSubPPtmpAAAL 1


XS(XS_Cairo__PdfSurface_set_size); /* prototype to pass -Wmissing-prototypes */
XS(XS_Cairo__PdfSurface_set_size)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       croak_xs_usage(cv,  "surface, width_in_points, height_in_points");
    {
	cairo_surface_t *	surface = SvCairoSurface (ST(0));
	double	width_in_points = (double)SvNV(ST(1));
	double	height_in_points = (double)SvNV(ST(2));

	cairo_pdf_surface_set_size(surface, width_in_points, height_in_points);
    }
    XSRETURN_EMPTY;
}

#endif
#if CAIRO_VERSION >= CAIRO_VERSION_ENCODE(1, 10, 0)
#define XSubPPtmpAAAM 1


XS(XS_Cairo__PdfSurface_restrict_to_version); /* prototype to pass -Wmissing-prototypes */
XS(XS_Cairo__PdfSurface_restrict_to_version)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "surface, version");
    {
	cairo_surface_t *	surface = SvCairoSurface (ST(0));
	cairo_pdf_version_t	version = SvCairoPdfVersion (ST(1));

	cairo_pdf_surface_restrict_to_version(surface, version);
    }
    XSRETURN_EMPTY;
}


XS(XS_Cairo__PdfSurface_get_versions); /* prototype to pass -Wmissing-prototypes */
XS(XS_Cairo__PdfSurface_get_versions)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 0 || items > 1)
       croak_xs_usage(cv,  "class=NULL");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 549 "CairoSurface.xs"
	cairo_pdf_version_t const *versions = NULL;
	int num_versions = 0, i;
#line 1250 "CairoSurface.c"
#line 552 "CairoSurface.xs"
	PERL_UNUSED_VAR (ax);
	cairo_pdf_get_versions (&versions, &num_versions);
	EXTEND (sp, num_versions);
	for (i = 0; i < num_versions; i++)
		PUSHs (sv_2mortal (newSVCairoPdfVersion (versions[i])));
#line 1257 "CairoSurface.c"
	PUTBACK;
	return;
    }
}


XS(XS_Cairo__PdfSurface_version_to_string); /* prototype to pass -Wmissing-prototypes */
XS(XS_Cairo__PdfSurface_version_to_string)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    PERL_UNUSED_VAR(cv); /* -W */
    {
	const char *	RETVAL;
	dXSTARG;
#line 562 "CairoSurface.xs"
	if (items == 1) {
		RETVAL = cairo_pdf_version_to_string (SvCairoPdfVersion (ST (0)));
	} else if (items == 2) {
		RETVAL = cairo_pdf_version_to_string (SvCairoPdfVersion (ST (1)));
	} else {
		RETVAL = NULL;
		croak ("Usage: Cairo::PdfSurface::version_to_string (version) or Cairo::PdfSurface->version_to_string (version)");
	}
#line 1285 "CairoSurface.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}

#endif
#endif
#ifdef CAIRO_HAS_PS_SURFACE
#define XSubPPtmpAAAN 1


XS(XS_Cairo__PsSurface_create); /* prototype to pass -Wmissing-prototypes */
XS(XS_Cairo__PsSurface_create)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 4)
       croak_xs_usage(cv,  "class, filename, width_in_points, height_in_points");
    {
	cairo_surface_t_noinc *	RETVAL;
	const char *	filename = (const char *)SvPV_nolen(ST(1));
	double	width_in_points = (double)SvNV(ST(2));
	double	height_in_points = (double)SvNV(ST(3));

	RETVAL = cairo_ps_surface_create(filename, width_in_points, height_in_points);
#line 591 "CairoSurface.xs"
#if CAIRO_VERSION < CAIRO_VERSION_ENCODE(1, 2, 0)
	cairo_perl_package_table_insert (RETVAL, "Cairo::PsSurface");
#endif
#line 1318 "CairoSurface.c"
	ST(0) = newSVCairoSurface_noinc (RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Cairo__PsSurface_create_for_stream); /* prototype to pass -Wmissing-prototypes */
XS(XS_Cairo__PsSurface_create_for_stream)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 5)
       croak_xs_usage(cv,  "class, func, data, width_in_points, height_in_points");
    {
#line 599 "CairoSurface.xs"
	CairoPerlCallback *callback;
#line 1339 "CairoSurface.c"
	cairo_surface_t_noinc *	RETVAL;
	SV *	func = ST(1);
	SV *	data = ST(2);
	double	width_in_points = (double)SvNV(ST(3));
	double	height_in_points = (double)SvNV(ST(4));
#line 601 "CairoSurface.xs"
	callback = cairo_perl_callback_new (func, data);
	RETVAL = cairo_ps_surface_create_for_stream (write_func_marshaller,
	                                             callback,
	                                             width_in_points,
	                                             height_in_points);
	cairo_surface_set_user_data (
		RETVAL, (const cairo_user_data_key_t *) &callback, callback,
		(cairo_destroy_func_t) cairo_perl_callback_free);
#if CAIRO_VERSION < CAIRO_VERSION_ENCODE(1, 2, 0)
	cairo_perl_package_table_insert (RETVAL, "Cairo::PsSurface");
#endif
#line 1357 "CairoSurface.c"
	ST(0) = newSVCairoSurface_noinc (RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}

#if CAIRO_VERSION >= CAIRO_VERSION_ENCODE(1, 2, 0)
#define XSubPPtmpAAAO 1


XS(XS_Cairo__PsSurface_set_size); /* prototype to pass -Wmissing-prototypes */
XS(XS_Cairo__PsSurface_set_size)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       croak_xs_usage(cv,  "surface, width_in_points, height_in_points");
    {
	cairo_surface_t *	surface = SvCairoSurface (ST(0));
	double	width_in_points = (double)SvNV(ST(1));
	double	height_in_points = (double)SvNV(ST(2));

	cairo_ps_surface_set_size(surface, width_in_points, height_in_points);
    }
    XSRETURN_EMPTY;
}


XS(XS_Cairo__PsSurface_dsc_comment); /* prototype to pass -Wmissing-prototypes */
XS(XS_Cairo__PsSurface_dsc_comment)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "surface, comment");
    {
	cairo_surface_t *	surface = SvCairoSurface (ST(0));
	const char *	comment = (const char *)SvPV_nolen(ST(1));

	cairo_ps_surface_dsc_comment(surface, comment);
    }
    XSRETURN_EMPTY;
}


XS(XS_Cairo__PsSurface_dsc_begin_setup); /* prototype to pass -Wmissing-prototypes */
XS(XS_Cairo__PsSurface_dsc_begin_setup)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "surface");
    {
	cairo_surface_t *	surface = SvCairoSurface (ST(0));

	cairo_ps_surface_dsc_begin_setup(surface);
    }
    XSRETURN_EMPTY;
}


XS(XS_Cairo__PsSurface_dsc_begin_page_setup); /* prototype to pass -Wmissing-prototypes */
XS(XS_Cairo__PsSurface_dsc_begin_page_setup)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "surface");
    {
	cairo_surface_t *	surface = SvCairoSurface (ST(0));

	cairo_ps_surface_dsc_begin_page_setup(surface);
    }
    XSRETURN_EMPTY;
}

#endif
#if CAIRO_VERSION >= CAIRO_VERSION_ENCODE(1, 6, 0)
#define XSubPPtmpAAAP 1


XS(XS_Cairo__PsSurface_restrict_to_level); /* prototype to pass -Wmissing-prototypes */
XS(XS_Cairo__PsSurface_restrict_to_level)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "surface, level");
    {
	cairo_surface_t *	surface = SvCairoSurface (ST(0));
	cairo_ps_level_t	level = SvCairoPsLevel (ST(1));

	cairo_ps_surface_restrict_to_level(surface, level);
    }
    XSRETURN_EMPTY;
}


XS(XS_Cairo__PsSurface_get_levels); /* prototype to pass -Wmissing-prototypes */
XS(XS_Cairo__PsSurface_get_levels)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 0 || items > 1)
       croak_xs_usage(cv,  "class=NULL");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 635 "CairoSurface.xs"
	cairo_ps_level_t const *levels = NULL;
	int num_levels = 0, i;
#line 1487 "CairoSurface.c"
#line 638 "CairoSurface.xs"
	PERL_UNUSED_VAR (ax);
	cairo_ps_get_levels (&levels, &num_levels);
	EXTEND (sp, num_levels);
	for (i = 0; i < num_levels; i++)
		PUSHs (sv_2mortal (newSVCairoPsLevel (levels[i])));
#line 1494 "CairoSurface.c"
	PUTBACK;
	return;
    }
}


XS(XS_Cairo__PsSurface_level_to_string); /* prototype to pass -Wmissing-prototypes */
XS(XS_Cairo__PsSurface_level_to_string)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    PERL_UNUSED_VAR(cv); /* -W */
    {
	const char *	RETVAL;
	dXSTARG;
#line 648 "CairoSurface.xs"
	if (items == 1) {
		RETVAL = cairo_ps_level_to_string (SvCairoPsLevel (ST (0)));
	} else if (items == 2) {
		RETVAL = cairo_ps_level_to_string (SvCairoPsLevel (ST (1)));
	} else {
		RETVAL = NULL;
		croak ("Usage: Cairo::PsSurface::level_to_string (level) or Cairo::PsSurface->level_to_string (level)");
	}
#line 1522 "CairoSurface.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_Cairo__PsSurface_set_eps); /* prototype to pass -Wmissing-prototypes */
XS(XS_Cairo__PsSurface_set_eps)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "surface, eps");
    {
	cairo_surface_t *	surface = SvCairoSurface (ST(0));
	cairo_bool_t	eps = (cairo_bool_t)SvUV(ST(1));

	cairo_ps_surface_set_eps(surface, eps);
    }
    XSRETURN_EMPTY;
}


XS(XS_Cairo__PsSurface_get_eps); /* prototype to pass -Wmissing-prototypes */
XS(XS_Cairo__PsSurface_get_eps)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "surface");
    {
	cairo_bool_t	RETVAL;
	dXSTARG;
	cairo_surface_t *	surface = SvCairoSurface (ST(0));

	RETVAL = cairo_ps_surface_get_eps(surface);
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}

#endif
#endif
#ifdef CAIRO_HAS_SVG_SURFACE
#define XSubPPtmpAAAQ 1


XS(XS_Cairo__SvgSurface_create); /* prototype to pass -Wmissing-prototypes */
XS(XS_Cairo__SvgSurface_create)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 4)
       croak_xs_usage(cv,  "class, filename, width_in_points, height_in_points");
    {
	cairo_surface_t_noinc *	RETVAL;
	const char *	filename = (const char *)SvPV_nolen(ST(1));
	double	width_in_points = (double)SvNV(ST(2));
	double	height_in_points = (double)SvNV(ST(3));

	RETVAL = cairo_svg_surface_create(filename, width_in_points, height_in_points);
	ST(0) = newSVCairoSurface_noinc (RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Cairo__SvgSurface_create_for_stream); /* prototype to pass -Wmissing-prototypes */
XS(XS_Cairo__SvgSurface_create_for_stream)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 5)
       croak_xs_usage(cv,  "class, func, data, width_in_points, height_in_points");
    {
#line 689 "CairoSurface.xs"
	CairoPerlCallback *callback;
#line 1613 "CairoSurface.c"
	cairo_surface_t_noinc *	RETVAL;
	SV *	func = ST(1);
	SV *	data = ST(2);
	double	width_in_points = (double)SvNV(ST(3));
	double	height_in_points = (double)SvNV(ST(4));
#line 691 "CairoSurface.xs"
	callback = cairo_perl_callback_new (func, data);
	RETVAL = cairo_svg_surface_create_for_stream (write_func_marshaller,
						      callback,
						      width_in_points,
						      height_in_points);
	cairo_surface_set_user_data (
		RETVAL, (const cairo_user_data_key_t *) &callback, callback,
		(cairo_destroy_func_t) cairo_perl_callback_free);
#line 1628 "CairoSurface.c"
	ST(0) = newSVCairoSurface_noinc (RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Cairo__SvgSurface_restrict_to_version); /* prototype to pass -Wmissing-prototypes */
XS(XS_Cairo__SvgSurface_restrict_to_version)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "surface, version");
    {
	cairo_surface_t *	surface = SvCairoSurface (ST(0));
	cairo_svg_version_t	version = SvCairoSvgVersion (ST(1));

	cairo_svg_surface_restrict_to_version(surface, version);
    }
    XSRETURN_EMPTY;
}


XS(XS_Cairo__SvgSurface_get_versions); /* prototype to pass -Wmissing-prototypes */
XS(XS_Cairo__SvgSurface_get_versions)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 0 || items > 1)
       croak_xs_usage(cv,  "class=NULL");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 708 "CairoSurface.xs"
	cairo_svg_version_t const *versions = NULL;
	int num_versions = 0, i;
#line 1672 "CairoSurface.c"
#line 711 "CairoSurface.xs"
	PERL_UNUSED_VAR (ax);
	cairo_svg_get_versions (&versions, &num_versions);
	EXTEND (sp, num_versions);
	for (i = 0; i < num_versions; i++)
		PUSHs (sv_2mortal (newSVCairoSvgVersion (versions[i])));
#line 1679 "CairoSurface.c"
	PUTBACK;
	return;
    }
}


XS(XS_Cairo__SvgSurface_version_to_string); /* prototype to pass -Wmissing-prototypes */
XS(XS_Cairo__SvgSurface_version_to_string)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    PERL_UNUSED_VAR(cv); /* -W */
    {
	const char *	RETVAL;
	dXSTARG;
#line 721 "CairoSurface.xs"
	if (items == 1) {
		RETVAL = cairo_svg_version_to_string (SvCairoSvgVersion (ST (0)));
	} else if (items == 2) {
		RETVAL = cairo_svg_version_to_string (SvCairoSvgVersion (ST (1)));
	} else {
		RETVAL = NULL;
		croak ("Usage: Cairo::SvgSurface::version_to_string (version) or Cairo::SvgSurface->version_to_string (version)");
	}
#line 1707 "CairoSurface.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}

#endif
#ifdef CAIRO_HAS_RECORDING_SURFACE
#define XSubPPtmpAAAR 1


XS(XS_Cairo__RecordingSurface_create); /* prototype to pass -Wmissing-prototypes */
XS(XS_Cairo__RecordingSurface_create)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       croak_xs_usage(cv,  "class, content, extents");
    {
	cairo_surface_t_noinc *	RETVAL;
	cairo_content_t	content = SvCairoContent (ST(1));
	cairo_rectangle_t_ornull *	extents = SvCairoRectangle_ornull (ST(2));

	RETVAL = cairo_recording_surface_create(content, extents);
	ST(0) = newSVCairoSurface_noinc (RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Cairo__RecordingSurface_ink_extents); /* prototype to pass -Wmissing-prototypes */
XS(XS_Cairo__RecordingSurface_ink_extents)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "surface");
    {
	cairo_surface_t *	surface = SvCairoSurface (ST(0));
	double	x0;
	double	y0;
	double	width;
	double	height;

	cairo_recording_surface_ink_extents(surface, &x0, &y0, &width, &height);
	XSprePUSH;	EXTEND(SP,4);
	PUSHs(sv_newmortal());
	sv_setnv(ST(0), (double)x0);
	PUSHs(sv_newmortal());
	sv_setnv(ST(1), (double)y0);
	PUSHs(sv_newmortal());
	sv_setnv(ST(2), (double)width);
	PUSHs(sv_newmortal());
	sv_setnv(ST(3), (double)height);
    }
    XSRETURN(4);
}

#endif
#if CAIRO_VERSION >= CAIRO_VERSION_ENCODE(1, 6, 0)
#define XSubPPtmpAAAS 1


XS(XS_Cairo__Format_stride_for_width); /* prototype to pass -Wmissing-prototypes */
XS(XS_Cairo__Format_stride_for_width)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "format, width");
    {
	int	RETVAL;
	dXSTARG;
	cairo_format_t	format = SvCairoFormat (ST(0));
	int	width = (int)SvIV(ST(1));

	RETVAL = cairo_format_stride_for_width(format, width);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#endif
#ifdef __cplusplus
extern "C"
#endif
XS(boot_Cairo__Surface); /* prototype to pass -Wmissing-prototypes */
XS(boot_Cairo__Surface)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#endif
    XS_VERSION_BOOTCHECK ;

        newXS("Cairo::Surface::DESTROY", XS_Cairo__Surface_DESTROY, file);
        newXS("Cairo::Surface::create_similar", XS_Cairo__Surface_create_similar, file);
        newXS("Cairo::Surface::finish", XS_Cairo__Surface_finish, file);
        newXS("Cairo::Surface::status", XS_Cairo__Surface_status, file);
        newXS("Cairo::Surface::set_device_offset", XS_Cairo__Surface_set_device_offset, file);
#if XSubPPtmpAAAA
        newXS("Cairo::Surface::get_device_offset", XS_Cairo__Surface_get_device_offset, file);
        newXS("Cairo::Surface::set_fallback_resolution", XS_Cairo__Surface_set_fallback_resolution, file);
#endif
#if XSubPPtmpAAAB
        newXS("Cairo::Surface::get_fallback_resolution", XS_Cairo__Surface_get_fallback_resolution, file);
#endif
        newXS("Cairo::Surface::get_font_options", XS_Cairo__Surface_get_font_options, file);
        newXS("Cairo::Surface::flush", XS_Cairo__Surface_flush, file);
        newXS("Cairo::Surface::mark_dirty", XS_Cairo__Surface_mark_dirty, file);
        newXS("Cairo::Surface::mark_dirty_rectangle", XS_Cairo__Surface_mark_dirty_rectangle, file);
#if XSubPPtmpAAAC
        newXS("Cairo::Surface::get_type", XS_Cairo__Surface_get_type, file);
        newXS("Cairo::Surface::get_content", XS_Cairo__Surface_get_content, file);
#endif
#if XSubPPtmpAAAD
        newXS("Cairo::Surface::write_to_png", XS_Cairo__Surface_write_to_png, file);
        newXS("Cairo::Surface::write_to_png_stream", XS_Cairo__Surface_write_to_png_stream, file);
#endif
#if XSubPPtmpAAAE
        newXS("Cairo::Surface::copy_page", XS_Cairo__Surface_copy_page, file);
        newXS("Cairo::Surface::show_page", XS_Cairo__Surface_show_page, file);
#endif
#if XSubPPtmpAAAF
        newXS("Cairo::Surface::has_show_text_glyphs", XS_Cairo__Surface_has_show_text_glyphs, file);
#endif
#if XSubPPtmpAAAG
        newXS("Cairo::Surface::create_for_rectangle", XS_Cairo__Surface_create_for_rectangle, file);
#endif
        newXS("Cairo::ImageSurface::create", XS_Cairo__ImageSurface_create, file);
        newXS("Cairo::ImageSurface::create_for_data", XS_Cairo__ImageSurface_create_for_data, file);
#if XSubPPtmpAAAH
        newXS("Cairo::ImageSurface::get_data", XS_Cairo__ImageSurface_get_data, file);
        newXS("Cairo::ImageSurface::get_format", XS_Cairo__ImageSurface_get_format, file);
#endif
        newXS("Cairo::ImageSurface::get_width", XS_Cairo__ImageSurface_get_width, file);
        newXS("Cairo::ImageSurface::get_height", XS_Cairo__ImageSurface_get_height, file);
#if XSubPPtmpAAAI
        newXS("Cairo::ImageSurface::get_stride", XS_Cairo__ImageSurface_get_stride, file);
#endif
#if XSubPPtmpAAAJ
        newXS("Cairo::ImageSurface::create_from_png", XS_Cairo__ImageSurface_create_from_png, file);
        newXS("Cairo::ImageSurface::create_from_png_stream", XS_Cairo__ImageSurface_create_from_png_stream, file);
#endif
#if XSubPPtmpAAAK
        newXS("Cairo::PdfSurface::create", XS_Cairo__PdfSurface_create, file);
        newXS("Cairo::PdfSurface::create_for_stream", XS_Cairo__PdfSurface_create_for_stream, file);
#if XSubPPtmpAAAL
        newXS("Cairo::PdfSurface::set_size", XS_Cairo__PdfSurface_set_size, file);
#endif
#if XSubPPtmpAAAM
        newXS("Cairo::PdfSurface::restrict_to_version", XS_Cairo__PdfSurface_restrict_to_version, file);
        newXS("Cairo::PdfSurface::get_versions", XS_Cairo__PdfSurface_get_versions, file);
        newXS("Cairo::PdfSurface::version_to_string", XS_Cairo__PdfSurface_version_to_string, file);
#endif
#endif
#if XSubPPtmpAAAN
        newXS("Cairo::PsSurface::create", XS_Cairo__PsSurface_create, file);
        newXS("Cairo::PsSurface::create_for_stream", XS_Cairo__PsSurface_create_for_stream, file);
#if XSubPPtmpAAAO
        newXS("Cairo::PsSurface::set_size", XS_Cairo__PsSurface_set_size, file);
        newXS("Cairo::PsSurface::dsc_comment", XS_Cairo__PsSurface_dsc_comment, file);
        newXS("Cairo::PsSurface::dsc_begin_setup", XS_Cairo__PsSurface_dsc_begin_setup, file);
        newXS("Cairo::PsSurface::dsc_begin_page_setup", XS_Cairo__PsSurface_dsc_begin_page_setup, file);
#endif
#if XSubPPtmpAAAP
        newXS("Cairo::PsSurface::restrict_to_level", XS_Cairo__PsSurface_restrict_to_level, file);
        newXS("Cairo::PsSurface::get_levels", XS_Cairo__PsSurface_get_levels, file);
        newXS("Cairo::PsSurface::level_to_string", XS_Cairo__PsSurface_level_to_string, file);
        newXS("Cairo::PsSurface::set_eps", XS_Cairo__PsSurface_set_eps, file);
        newXS("Cairo::PsSurface::get_eps", XS_Cairo__PsSurface_get_eps, file);
#endif
#endif
#if XSubPPtmpAAAQ
        newXS("Cairo::SvgSurface::create", XS_Cairo__SvgSurface_create, file);
        newXS("Cairo::SvgSurface::create_for_stream", XS_Cairo__SvgSurface_create_for_stream, file);
        newXS("Cairo::SvgSurface::restrict_to_version", XS_Cairo__SvgSurface_restrict_to_version, file);
        newXS("Cairo::SvgSurface::get_versions", XS_Cairo__SvgSurface_get_versions, file);
        newXS("Cairo::SvgSurface::version_to_string", XS_Cairo__SvgSurface_version_to_string, file);
#endif
#if XSubPPtmpAAAR
        newXS("Cairo::RecordingSurface::create", XS_Cairo__RecordingSurface_create, file);
        newXS("Cairo::RecordingSurface::ink_extents", XS_Cairo__RecordingSurface_ink_extents, file);
#endif
#if XSubPPtmpAAAS
        newXS("Cairo::Format::stride_for_width", XS_Cairo__Format_stride_for_width, file);
#endif

    /* Initialisation Section */

#if XSubPPtmpAAAA
#endif
#if XSubPPtmpAAAB
#endif
#if XSubPPtmpAAAC
#endif
#if XSubPPtmpAAAD
#endif
#if XSubPPtmpAAAE
#endif
#if XSubPPtmpAAAF
#endif
#if XSubPPtmpAAAG
#endif
#line 418 "CairoSurface.xs"
	cairo_perl_set_isa ("Cairo::ImageSurface", "Cairo::Surface");

#if XSubPPtmpAAAH
#endif
#if XSubPPtmpAAAI
#endif
#if XSubPPtmpAAAJ
#endif
#if XSubPPtmpAAAK
#line 504 "CairoSurface.xs"
	cairo_perl_set_isa ("Cairo::PdfSurface", "Cairo::Surface");

#if XSubPPtmpAAAL
#endif
#if XSubPPtmpAAAM
#endif
#endif
#if XSubPPtmpAAAN
#line 584 "CairoSurface.xs"
	cairo_perl_set_isa ("Cairo::PsSurface", "Cairo::Surface");

#if XSubPPtmpAAAO
#endif
#if XSubPPtmpAAAP
#endif
#endif
#if XSubPPtmpAAAQ
#line 677 "CairoSurface.xs"
	cairo_perl_set_isa ("Cairo::SvgSurface", "Cairo::Surface");

#endif
#if XSubPPtmpAAAR
#line 744 "CairoSurface.xs"
	cairo_perl_set_isa ("Cairo::RecordingSurface", "Cairo::Surface");

#endif
#if XSubPPtmpAAAS
#endif
#line 1972 "CairoSurface.c"

    /* End of Initialisation Section */

#if (PERL_REVISION == 5 && PERL_VERSION >= 9)
  if (PL_unitcheckav)
       call_list(PL_scopestack_ix, PL_unitcheckav);
#endif
    XSRETURN_YES;
}

